<?php
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Filename: includes\blocks\visitscounter.php
// Original Author of file: Jaroslaw Gilewski (http://www.yagi.com.pl)
// Purpose of file: Counting and display user visits on your site.
// ----------------------------------------------------------------------

$blocks_modules['visitscounter']=array(
    'func_display'=>'blocks_visitscounter_block',
    'text_type'=>'Visits Counter',
    'text_type_long'=>'Visits Counter',
    'allow_multiple'=>false,
    'form_content'=>false,
    'form_refresh'=>false,
    'show_preview'=>true);

function blocks_visitscounter_block($row)
{
  global $prefix, $bgcolor4;
  list($dbconn) = pnDBGetConn(); 
    
  $pntable['visits_log'] = $prefix.'_visits_log';
  $pntable['visits_log_column'] = array ('visitid'        => "$pntable[visits_log].visitid",
                                         'visitdatetime'  => "$pntable[visits_log].visitdatetime",
                                         'visitip'        => "$pntable[visits_log].visitip",
                                         'visithost'        => "$pntable[visits_log].visithost");

  $pntable['visits_stat'] = $prefix.'_visits_stat';
  $pntable['visits_stat_column'] = array ('visityear'        => "$pntable[visits_stat].visityear",
                                          'visitmonth'        => "$pntable[visits_stat].visitmonth",
                                          'visitday'        => "$pntable[visits_stat].visitday",
                                          'visithits'        => "$pntable[visits_stat].visithits");
  
  $now = time();
  $visityear = date("Y", $now);
  $visitmonth = date("m", $now);
  $visitday = date("d", $now);
  $logdatetime =  date("Y-m-d H:i:s", $now);
  $logip = getenv("REMOTE_ADDR");
  if (gethostbyaddr($logip))
    $loghost = gethostbyaddr($logip);
  else
    $loghost = 'Unknown';
  
  $column = &$pntable['visits_log_column'];
  $result = $dbconn->SelectLimit("SELECT $column[visitip], $column[visitdatetime] 
                                  FROM $pntable[visits_log] 
                                  WHERE $column[visitip]='$logip'
                                  ORDER BY $column[visitdatetime] DESC", 1);
  if (!$result->EOF)
      list($visitip, $visitdatetime) = $result->fields;
  $result->Close();
  
  $pastdatetime = date("Y-m-d H:i:s", $now - 43200);
  if (!isset($visitip) || (isset($visitip) && $visitdatetime < $pastdatetime))
    $visitvalid = 1;
  else
    $visitvalid = 0;  
  
  if($visitvalid == 1)
  {
      $visityear = date("Y", $now);
      $visitmonth = date("m", $now);
      $visitday = date("d", $now);
      
      $column = &$pntable['visits_log_column'];
      $nextid = $dbconn->GenId($pntable['visits_log']);
      $dbconn->Execute("INSERT INTO $pntable[visits_log]
                        ($column[visitid], $column[visitdatetime], $column[visitip], $column[visithost])
                        VALUES ($nextid, '$logdatetime','$logip', '$loghost')");
                        
      $column = &$pntable['visits_stat_column'];
      $result = $dbconn->Execute("SELECT $column[visithits] 
                                 FROM $pntable[visits_stat] 
                                 WHERE $column[visityear]='$visityear' AND
                                       $column[visitmonth]='$visitmonth' AND
                                       $column[visitday]='$visitday'");
      if($result->EOF){
          $dbconn->Execute("INSERT INTO $pntable[visits_stat]
                            ($column[visityear], $column[visitmonth], $column[visitday], $column[visithits])
                            VALUES ('$visityear', '$visitmonth', '$visitday', '1')");
      } else{
          list($visithits) = $result->fields;
          $visithits += 1;
          $dbconn->Execute("UPDATE $pntable[visits_stat]
                            SET $column[visithits] = '$visithits'
                            WHERE $column[visityear]='$visityear' AND
                                  $column[visitmonth]='$visitmonth' AND
                                  $column[visitday]='$visitday'");
      }
      $result->Close();
  }

  $content .= "<TABLE WIDTH=\"95%\" BORDER=\"0\" CELLSPACING=\"1\" CELLPADDING=\"0\">";
  //Today
  $column = &$pntable['visits_stat_column'];
  $result = $dbconn->Execute("SELECT $column[visithits]
                            FROM $pntable[visits_stat] 
                            WHERE $column[visityear] = '$visityear' AND
                                  $column[visitmonth] = '$visitmonth' AND
                                  $column[visitday] = '$visitday'");
  if (!$result->EOF)
    list($visithits) = $result->fields;
  else
    $visithits = '0';
  $result->Close();
  $content .= "<TR><TD ALIGN=\"RIGHT\">"._VC_COUNTERTODAY.":</TD><TD><b>$visithits</b></TD></TR>";
  
  //This month
  $column = &$pntable['visits_stat_column'];
  $result = $dbconn->Execute("SELECT sum($column[visithits])
                            FROM $pntable[visits_stat] 
                            WHERE $column[visityear] = '$visityear' AND
                                  $column[visitmonth] = '$visitmonth'");
  if (!$result->EOF)
    list($visithits) = $result->fields;
  else
    $visithits = '0';
  $result->Close();
  $content .= "<TR><TD ALIGN=\"RIGHT\">"._VC_COUNTERTHISMONTH.":</TD><TD><b>$visithits</b></TD></TR>";
  
  //This year
  $column = &$pntable['visits_stat_column'];
  $result = $dbconn->Execute("SELECT sum($column[visithits])
                            FROM $pntable[visits_stat] 
                            WHERE $column[visityear] = '$visityear'");
  if (!$result->EOF)
    list($visithits) = $result->fields;
  else
    $visithits = '0';
  $result->Close();
  $content .= "<TR><TD ALIGN=\"RIGHT\">"._VC_COUNTERTHISYEAR.":</TD><TD><b>$visithits</b></TD></TR>";

  //This year
  $column = &$pntable['visits_stat_column'];
  $result = $dbconn->Execute("SELECT sum($column[visithits])
                            FROM $pntable[visits_stat]");
  if (!$result->EOF)
    list($visithits) = $result->fields;
  else
    $visithits = '0';
  $result->Close();
  $content .= "<TR><TD ALIGN=\"RIGHT\" BGCOLOR=\"$bgcolor4\">"._VC_COUNTERTOTAL.":</TD><TD BGCOLOR=\"$bgcolor4\"><b>$visithits</b></TD></TR></TABLE>";

  $column = &$pntable['visits_stat_column'];
  $result = $dbconn->SelectLimit("SELECT $column[visityear], $column[visitmonth], $column[visitday] 
                                  FROM $pntable[visits_stat] 
                                  ORDER BY $column[visityear], $column[visitmonth], $column[visitday]",1);
  if (!$result->EOF){
      list($visityear, $visitmonth, $visitday) = $result->fields;
      $content .= "<DIV align=\"right\"><br><small>"._VC_FROMDAY." ".ml_ftime(_DATEBRIEF, (GetUserTime(mktime(0, 0, 0, $visitmonth, $visitday, $visityear))))."</small></DIV>";
  }
  $result->Close();  
  
  $row[title] = _VC_COUNTERTITLE;
  $row[content] = $content;
  
  themesideblock($row);
}

?>